/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package es.rickyepoderi.weaving;

import java.io.PrintWriter;
import java.net.URL;
import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.EntityTransaction;
import javax.persistence.Persistence;

/**
 *
 * @author ricky
 */
public class Test {
    
    private void prueba(PrintWriter out) throws Exception {
        EntityManagerFactory emf = Persistence.createEntityManagerFactory("elunit");
        EntityManager em = emf.createEntityManager();
        out.println("Delegate: " + em.getDelegate() + "<br/>");
        Class clazz = em.getDelegate().getClass();
        URL location = clazz.getResource('/' + clazz.getName().replace('.', '/') + ".class");
        out.println("Location:" + location + "<br/>");
        
        // test the problem
        Sample s = new Sample();
        s.setId("AC98");
        
        // get the detached object
        out.println("Obtaining a detached sample...");
        em = emf.createEntityManager();
        EntityTransaction entityTransaction = em.getTransaction();
        entityTransaction.begin();
        s = em.find(Sample.class, s.getId());
        if (s == null) {
            out.println("Creating the sample cos it doesn't exist...");
            s = new Sample();
            s.setId("AC98");
            s.setName("AC98");
            s.setDescription("AC98");
            s = (Sample) em.merge(s);
            s = em.find(Sample.class, s.getId());
        }
        entityTransaction.commit();
        //em.clear();
        //((EntityManagerImpl)em.getDelegate()).detach(s);
        em.close();
        
        // copying it works!!!
        //IgaeSample s2 = new Sample();
        //s2.setId(s.getId());
        //s2.setName(s.getName());
        //s2.setDescription(s.getDescription());
        //s = s2;        
        
        // create the merge object with a diferrent id
        out.println("Creating a merge sample from the detached...");
        s.setId("AC99");
        em = emf.createEntityManager();
        entityTransaction = em.getTransaction();
        entityTransaction.begin();
        //em.clear();
        //((EntityManagerImpl)em.getDelegate()).detach(s);
        em.merge(s);
        entityTransaction.commit();
        em.close();
        
        out.flush();
    }

    public static void main(String[] args) throws Exception {
        Test t = new Test();
        t.prueba(new PrintWriter(System.err));
    }
    

}
